﻿Imports System.Security.Cryptography
Imports System.Text

Public Class Form1
    Private Function HashUserInformation(ByVal userName As String, ByVal password As String) As String
        Dim pBytes() As Byte = Encoding.UTF8.GetBytes(userName & password)
        Dim hBytes() As Byte = New MD5CryptoServiceProvider().ComputeHash(pBytes)

        'Hash wird aus UserName und Password gebildet
        Return BitConverter.ToString(hBytes).Replace("-", "")
    End Function

    Private Sub AddNewUser(ByVal userName As String, ByVal password As String)
        Dim hPassword As String = HashUserInformation(userName, password)

        Me.UserDataSet1.Users.AddUsersRow(userName, hPassword, True)
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'Nur zur Demo einen User anlegen.
        AddNewUser("SpaceyX", "myPassword")
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If Not Me.TextBox1.Text = "" AndAlso Not Me.TextBox2.Text = "" Then
            Dim userName As String = Me.TextBox1.Text
            Dim password As String = Me.TextBox2.Text
            Dim result = From p In Me.UserDataSet1.Users Where p.UserName = userName Select p

            If result.Count = 1 Then
                If result(0).IsClosedOff Then
                    MessageBox.Show("Dieser User ist gesperrt")

                    Exit Sub
                End If

                Dim givenPassword As String = HashUserInformation(userName, password)

                If givenPassword = result(0).PasswordHash Then
                    MessageBox.Show("Login OK")
                Else
                    MessageBox.Show("Passwort nicht korrekt")
                End If
            Else
                MessageBox.Show("Dieser User existiert nicht")
            End If
        End If
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim userName As String = Me.TextBox1.Text
        Dim passWord As String = Me.TextBox2.Text
        Dim hPassword As String = HashUserInformation(userName, passWord)

        Try
            Me.UserDataSet1.Users.AddUsersRow(userName, hPassword, False)
        Catch ex As System.Data.ConstraintException
            MessageBox.Show("Dieser User existiert bereits")
        End Try
    End Sub
End Class
